var datosMisPlantas=[];
var idPlanta=''; //Identificador de la planta de interior (edición)
var idIndice=''; //Identificador de la planta de catálogo

var dataTableMisPlantas;
var nombre;
var descripcion;
var ultimoRiego;
var frecuencia;
var luz;
var temperatura;
var humedad;
var riego;
var abono;
var trasplante;
var limpieza;
var poda;
var multiplicacion;
var floracion;
var substrato;
var trastornos;
var descanso;
var info_adicional;



$(document).ready(function() {
    if ($('#tablaMisPlantas').length>0){
        cargarMisPlantas();
    }

    if ($('#detalleMiPlanta').length>0){
        var search = $(location).attr('search');
        console.log('PREVIO, idIndice='+idIndice+', idPlanta='+idPlanta);
        console.log('search=>'+search);
        //Identificador de la planta de catálogo
        if (search.indexOf('idIndice') > -1){
            console.log('    entra en idIndice');
            idIndice = search.substring(search.indexOf('idIndice')+9,search.indexOf('&'));
            $('#idIndice').val(idIndice);
        }
        //Identificador de la planta
        if (search.indexOf('idPlanta') > -1) {
            console.log('    entra en idPlanta');
            idPlanta = search.substring(search.indexOf('idPlanta')+9,search.indexOf('&'));
            $('#idPlantaInterior').val(idPlanta);
        }
        preEdicionInsercionPlanta();
    }
} );

/**********************/
/* LISTADO DE PLANTAS */
/**********************/

function cargarMisPlantas(){
    console.log('  cargarMisPlantas');
    document.addEventListener("deviceready", onDeviceReady, true);
}

function onDeviceReady() {
    console.log('      DeviceReady');

    var mydb = openDatabase('iPlantaInterior', '1.0', 'iPlantaInterior DB', 10 * 1024);
    mydb.transaction(populateDB, errorCB, successCB);
}

function populateDB(tx){
    console.log('      PopulateDB');
    var query = 'SELECT MP.ID_MI_PLANTA, MP.ID_PLANTA, MP.NOMBRE, PC.IMAGEN '
        +' FROM MI_PLANTA MP '
        +' LEFT OUTER  join PLANTA_CATALOGO PC  ON MP.ID_PLANTA = PC.ID_PLANTA_CATALOGO '
        +' ORDER BY MP.NOMBRE;';
    tx.executeSql(query, [],
        function(transaction, result) {
            if (result != null && result.rows != null) {
                for (var i = 0; i < result.rows.length; i++) {
                    var row = result.rows.item(i);
                    var fila = [''+row.ID_MI_PLANTA,(row.IMAGEN)?''+row.IMAGEN:'', ''+row.NOMBRE];
                    datosMisPlantas.push(fila);
                }
            }

            dataTableMisPlantas = $('#tablaMisPlantas').DataTable({
                "lengthChange": false,
                data: datosMisPlantas,
                "order": [[2, "asc"]],
                "columns": [
                    // Ordenacion y ancho de columnas
                    {},
                    { orderable: false, width: "20%"},
                    {},
                    { orderable: false, width: "10%"},
                ],
                "columnDefs": [
                    {
                        "targets": [0],
                        "visible": false,
                        "searchable": false
                    },
                    {
                        // Renderizacion de las celdas
                        "render": function ( data, type, row ) {
                            if (row[1]!=null && row[1].length>0){
                                return '<img src="' + row[1] + '" alt="Imagen '+row[2]+'"/>';
                            }
                            else{
                                return '';
                            }
                        },
                        "targets": [1]
                    },
                    {
                        // Renderizacion de las celdas
                        "render": function ( data, type, row ) {
                            return '<div class="iconDetalle" id="irDetalleMiPlanta" ident="'+row[0]+'"><i class="fas fa-arrow-right" ></i></div>';
                        },
                        "targets": [3]
                    }
                ],
                // Traducciones de la tabla
                "language": {
                    "processing":     "Procesando...",
                    "lengthMenu":     "Mostrar _MENU_ registros",
                    "zeroRecords":    "No se encontraron resultados",
                    "emptyTable":     "Ningún dato disponible en esta tabla",
                    "info":           "Mostrando registros del _START_ al _END_ de un total de _TOTAL_ registros",
                    "infoEmpty":      "0 - 0 de 0",
                    "infoFiltered":   "(filtrado de un total de _MAX_ registros)",
                    "infoPostFix":    "",
                    "search":         "Buscar:   ",
                    "thousands":  ",",
                    "loadingRecords": "Cargando...",
                    "paginate": {
                        "first":    "<i class='glyphicon glyphicon-chevron-left'></i><i class='glyphicon glyphicon-chevron-left'></i>",
                        "last":     "<i class='glyphicon glyphicon-chevron-right'></i><i class='glyphicon glyphicon-chevron-right'></i>",
                        "next":     "<i class='glyphicon glyphicon-chevron-right'></i>",
                        "previous": "<i class='glyphicon glyphicon-chevron-left'></i>"
                    },
                    "aria": {
                        "sortAscending":  ": Activar para ordenar la columna de manera ascendente",
                        "sortDescending": ": Activar para ordenar la columna de manera descendente"
                    }
                },
                "initComplete" : function() {
                    var altura = parseInt($(window).height() - $('#migaPan').height() - $('#tablaMisPlantas_filter').height() - $('.menu').height());
                    var altoFila = 130;
                    if ( parseInt($(window).height())<= 750) {
                        altoFila = 60;
                    }
                    var filas = Math.trunc(altura/altoFila)-1;
                    $('#tablaMisPlantas').DataTable().page.len(filas).draw();
                },
                pageResize: true,
                paging: false,
                info: false
            });
            
        },
    errorHandler);

}

//Edición de mi planta desde el listado
$(document).on("click",'#irDetalleMiPlanta', function ()
{
    var id = $(this).attr("ident");
    window.location.href = './miPlanta.html?idPlanta='+id+'&';
});

$(document).on("touchend",'#irDetalleMiPlanta', function ()
{
    var id = $(this).attr("ident");
    window.location.href = './miPlanta.html?idPlanta='+id+'&';
});

//Inserción nueva planta desde el listado de plantas
$(document).on("click",'#nuevaPlanta', function ()
{
    window.location.href = './miPlanta.html';
});

function onFail(message) {
    console.log('    ERROR:' + message);
}


/********************************************/
/* PAGINA DE INSERCION/EDICION NUEVA PLANTA */
/********************************************/

function preEdicionInsercionPlanta(){
    if (idPlanta.length > 0){
        //Edicion
        console.log('  Pre Edicion=> idPlanta='+idPlanta);
        document.addEventListener("deviceready", onDeviceReadyEdicion, true);
    }
    else{
        //Insercion
        console.log('  Pre Insercion => idIndice=>'+idIndice);
        document.addEventListener("deviceready", onDeviceReadyInsercion, true);
    }
}

function onDeviceReadyEdicion() {
    console.log('      onDeviceReadyEdicion');
    var mydb = openDatabase('iPlantaInterior', '1.0', 'iPlantaInterior DB', 10 * 1024);
    mydb.transaction(populateDBEdicion, errorCB, successCB);
}

function onDeviceReadyInsercion() {
    console.log('      onDeviceReadyInsercion');
    var mydb = openDatabase('iPlantaInterior', '1.0', 'iPlantaInterior DB', 10 * 1024);
    mydb.transaction(populateDBInsercion, errorCB, successCB);

    //Se oculta boton de eliminar
    $('.eliminar').hide();
    $('.eliminar').css("display", "none");

    //Fecha actual para el ultimo riego
    var fechaActual = new Date();
    $('#ultimoRiego').val(toDateInputValue(fechaActual));
    $('#frecuencia').val('0');

}



//Detalles de la planta para la edicion
function populateDBEdicion(tx){
    console.log('      populateDBEdicion, idPlanta=>'+idPlanta);
    var query = 'SELECT MP.ID_MI_PLANTA, MP.ID_PLANTA, MP.NOMBRE, MP.DESCRIPCION, MP.ULTIMO_RIEGO, MP.FRECUENCIA_RIEGO, PC.IMAGEN, '
        +'    MP.LUZ, MP.TEMPERATURA, MP.HUMEDAD, MP.RIEGO, MP.ABONO, MP.TRASPLANTE, MP.LIMPIEZA, MP.PODA, MP.MULTIPLICACION, MP.FLORACION, MP.SUBSTRATO, MP.TRASTORNOS, '
        +'    MP.DESCANSO, MP.INFO_ADICIONAL'
        +' FROM MI_PLANTA MP '
        +' LEFT OUTER  join PLANTA_CATALOGO PC  ON MP.ID_PLANTA = PC.ID_PLANTA_CATALOGO '
        +' WHERE MP.ID_MI_PLANTA='+idPlanta
        +' ORDER BY MP.NOMBRE;';
    tx.executeSql(query, [],
        function(transaction, result) {
            if (result != null && result.rows != null) {
                for (var i = 0; i < result.rows.length; i++) {
                    var row = result.rows.item(i);
                    $('#nombre').val(row.NOMBRE);
                    $('#nombreMiPlanta').html(row.NOMBRE);
                    $('#ultimoRiego').val(toDateInputValue(new Date(row.ULTIMO_RIEGO)));
                    console.log('    Frecuencia=>'+row.FRECUENCIA_RIEGO);
                    $('#frecuencia').val(row.FRECUENCIA_RIEGO);
                    if (row.DESCRIPCION!=null  && row.DESCRIPCION!='null' && row.DESCRIPCION.length>0){
                        $('#descripcion').val(row.DESCRIPCION);
                    }
                    if (row.IMAGEN!=null  && row.IMAGEN!='null' && row.IMAGEN.length>0){
                        $('#imagen1').attr('src',row.IMAGEN);
                    }
                    else{
                        $('#cardImagen').hide();
                        $("#cardImagen").css("display", "none");
                    }
                    
                    if (row.DESCRIPCION!=null && row.DESCRIPCION.length>0){
                        $('#desCuidado').html(row.DESCRIPCION);
                    }
                    else{
                        $('#cardDescripcion').hide();
                        $("#cardDescripcion").css("display", "none");
                    }

                    console.log('    luz>='+row.LUZ);
                    if (row.LUZ!=null && row.LUZ.length>0){
                        $('#luzPlanta').val(row.LUZ);
                    }

                    if (row.TEMPERATURA!=null && row.TEMPERATURA.length>0){
                        $('#temperaturaPlanta').val(row.TEMPERATURA);
                    }

                    if (row.HUMEDAD!=null && row.HUMEDAD.length>0){
                        $('#humedadPlanta').val(row.HUMEDAD);
                    }

                    if (row.RIEGO!=null && row.RIEGO.length>0){
                        $('#riegoPlanta').val(row.RIEGO);
                    }

                    if (row.ABONO!=null && row.ABONO.length>0){
                        $('#abonoPlanta').val(row.ABONO);
                    }

                    if (row.TRASPLANTE!=null && row.TRASPLANTE.length>0){
                        $('#traslantePlanta').val(row.TRASPLANTE);
                    }

                    if (row.LIMPIEZA!=null && row.LIMPIEZA.length>0){
                        $('#limpiezaPlanta').val(row.LIMPIEZA);
                    }

                    if (row.PODA!=null && row.PODA.length>0){
                        $('#podaPlanta').val(row.PODA);
                    }

                    if (row.MULTIPLICACION!=null && row.MULTIPLICACION.length>0){
                        $('#multiplicacionPlanta').val(row.MULTIPLICACION);
                    }

                    if (row.FLORACION!=null && row.FLORACION.length>0){
                        $('#floracionPlanta').val(row.FLORACION);
                    }

                    if (row.SUBSTRATO!=null && row.SUBSTRATO.length>0){
                        $('#substratoPlanta').val(row.SUBSTRATO);
                    }

                    if (row.TRASTORNOS!=null && row.TRASTORNOS.length>0){
                        $('#trastornoPlanta').val(row.TRASTORNOS);
                    }

                    if (row.DESCANSO!=null && row.DESCANSO.length>0){
                        $('#descansoPlanta').val(row.DESCANSO);
                    }

                    if (row.INFO_ADICIONAL!=null && row.INFO_ADICIONAL.length>0){
                        $('#infoAdicionalPlanta').val(row.INFO_ADICIONAL);
                    }
                }
            }
        },
    errorHandler);
}

//Detalles de la planta para la insercion
function populateDBInsercion(tx){
    console.log('      populateDBInsercion, idIndice=>'+idIndice);
    if (idIndice != undefined && idIndice.length >0){
        var query = 'select IMAGEN, LUZ, TEMPERATURA, HUMEDAD, RIEGO, ABONO, TRASPLANTE, LIMPIEZA, PODA, MULTIPLICACION, FLORACION, SUBSTRATO, TRASTORNOS, '
            + ' DESCANSO, INFO_ADICIONAL'
            + ' from PLANTA_CATALOGO where ID_PLANTA_CATALOGO='+idIndice+';';
        tx.executeSql(query, [],
            function(transaction, result) {
                if (result != null && result.rows != null) {
                    for (var i = 0; i < result.rows.length; i++) {
                        var row = result.rows.item(i);
                        if (row.IMAGEN!=null  && row.IMAGEN!='null' && row.IMAGEN.length>0){
                            $('#imagen1').attr('src',row.IMAGEN);
                        }
                        else{
                            $('#cardImagen').hide();
                            $("#cardImagen").css("display", "none");
                        }
                        
                        if (row.DESCRIPCION!=null && row.DESCRIPCION.length>0){
                            $('#desCuidado').html(row.DESCRIPCION);
                        }
                        else{
                            $('#cardDescripcion').hide();
                            $("#cardDescripcion").css("display", "none");
                        }

                        if (row.LUZ!=null && row.LUZ.length>0){
                            $('#luzPlanta').val(row.LUZ);
                        }

                        if (row.TEMPERATURA!=null && row.TEMPERATURA.length>0){
                            $('#temperaturaPlanta').val(row.TEMPERATURA);
                        }

                        if (row.HUMEDAD!=null && row.HUMEDAD.length>0){
                            $('#humedadPlanta').val(row.HUMEDAD);
                        }

                        if (row.RIEGO!=null && row.RIEGO.length>0){
                            $('#riegoPlanta').val(row.RIEGO);
                        }

                        if (row.ABONO!=null && row.ABONO.length>0){
                            $('#abonoPlanta').val(row.ABONO);
                        }

                        if (row.TRASPLANTE!=null && row.TRASPLANTE.length>0){
                            $('#traslantePlanta').val(row.TRASPLANTE);
                        }

                        if (row.LIMPIEZA!=null && row.LIMPIEZA.length>0){
                            $('#limpiezaPlanta').val(row.LIMPIEZA);
                        }

                        if (row.PODA!=null && row.PODA.length>0){
                            $('#podaPlanta').val(row.PODA);
                        }

                        if (row.MULTIPLICACION!=null && row.MULTIPLICACION.length>0){
                            $('#multiplicacionPlanta').val(row.MULTIPLICACION);
                        }

                        if (row.FLORACION!=null && row.FLORACION.length>0){
                            $('#floracionPlanta').val(row.FLORACION);
                        }

                        if (row.SUBSTRATO!=null && row.SUBSTRATO.length>0){
                            $('#substratoPlanta').val(row.SUBSTRATO);
                        }

                        if (row.TRASTORNOS!=null && row.TRASTORNOS.length>0){
                            $('#trastornoPlanta').val(row.TRASTORNOS);
                        }

                        if (row.DESCANSO!=null && row.DESCANSO.length>0){
                            $('#descansoPlanta').val(row.DESCANSO);
                        }

                        if (row.INFO_ADICIONAL!=null && row.INFO_ADICIONAL.length>0){
                            $('#infoAdicionalPlanta').val(row.INFO_ADICIONAL);
                        }
                    }
                }
            },
        errorHandler);
    
    }

}

//Click en Accept
$(document).on("click",'#btnNuevaPlanta', function ()
{
    var idPlanta = $('#idPlantaInterior').val();
    nombre = $('#nombre').val();
    descripcion = $('#descripcion').val();
    idIndice =  $('#idIndice').val();
    ultimoRiego = new Date($('#ultimoRiego').val()).getTime();
    frecuencia = $('#frecuencia').val();
    luz = $('#luzPlanta').val();
    temperatura = $('#temperaturaPlanta').val();
    humedad = $('#humedadPlanta').val();
    riego = $('#riegoPlanta').val();
    abono = $('#abonoPlanta').val();
    trasplante = $('#traslantePlanta').val();
    limpieza = $('#limpiezaPlanta').val();
    poda = $('#podaPlanta').val();
    multiplicacion = $('#multiplicacionPlanta').val();
    floracion = $('#floracionPlanta').val();
    substrato = $('#substratoPlanta').val();
    trastornos = $('#trastornoPlanta').val();
    descanso = $('#descansoPlanta').val();
    info_adicional = $('#infoAdicionalPlanta').val();

    if (nombre==undefined || nombre == null || nombre.length == 0){
        $('#modalMensaje').modal('show');
        $('#mensaje').html('Se debe especificar un nombre para la planta de interior');
        $('#nombre').css('background-color','red');
    }
    else{
        if (idPlanta!= undefined && idPlanta.length>0){
            console.log('    Edicion');
            var mydb = openDatabase('iPlantaInterior', '1.0', 'iPlantaInterior DB', 10 * 1024);
            mydb.transaction(editPlanta, errorCB, successCB);
        }
        else{
            console.log('    Inserción');
            var mydb = openDatabase('iPlantaInterior', '1.0', 'iPlantaInterior DB', 10 * 1024);
            mydb.transaction(newPlanta, errorCB, successCB);
        }
    }
});

//Click en Eliminar planta
$(document).on("click",'#btnEliminarMiPlanta', function ()
{
    console.log('Eliminar mi planta');
    var mydb = openDatabase('iPlantaInterior', '1.0', 'iPlantaInterior DB', 10 * 1024);
    mydb.transaction(deletePlanta, errorCB, successCB);
});

//Alta de planta
function newPlanta(tx){
    console.log('      newPlanta, idIndice=>'+idIndice);
    var idIndiceQuery = (idIndice != undefined && idIndice.length>0)?idIndice:null;
    var ultimoRiegoQuery = (ultimoRiego != undefined && ultimoRiego!=null)?ultimoRiego:null;
    var frecuenciaQuery = (frecuencia != undefined && frecuencia>0)?frecuencia:0;
    var luzQuery = (luz != undefined && luz.length>0)?luz:null;

    var temperaturaQuery = (temperatura != undefined && temperatura.length>0)?temperatura:null;
    var humedadQuery = (humedad != undefined && humedad.length>0)?humedad:null;
    var riegoQuery = (riego != undefined && riego.length>0)?riego:null;
    var abonoQuery = (abono != undefined && abono.length>0)?abono:null;
    var trasplanteQuery = (trasplante != undefined && trasplante.length>0)?trasplante:null;
    var limpiezaQuery = (limpieza != undefined && limpieza.length>0)?limpieza:null;
    var podaQuery = (poda != undefined && poda.length>0)?poda:null;
    var multiplicacionQuery = (multiplicacion != undefined && multiplicacion.length>0)?multiplicacion:null;
    var floracionQuery = (floracion != undefined && floracion.length>0)?floracion:null;
    var substratoQuery = (substrato != undefined && substrato.length>0)?substrato:null;
    var trastornosQuery = (trastornos != undefined && trastornos.length>0)?trastornos:null;
    var descansoQuery = (descanso != undefined && descanso.length>0)?descanso:null;
    var info_adicionalQuery = (info_adicional != undefined && info_adicional.length>0)?info_adicional:null;

    

    var query = 'INSERT INTO MI_PLANTA(NOMBRE,DESCRIPCION,ID_PLANTA,ULTIMO_RIEGO,FRECUENCIA_RIEGO,LUZ,TEMPERATURA,HUMEDAD,RIEGO,ABONO,TRASPLANTE,LIMPIEZA,PODA,MULTIPLICACION,FLORACION,SUBSTRATO,TRASTORNOS,DESCANSO,INFO_ADICIONAL) '
            +' VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)';
    tx.executeSql(query, [nombre, descripcion,parseInt(idIndiceQuery),ultimoRiego,parseInt(frecuenciaQuery),luzQuery,temperaturaQuery,humedadQuery,riegoQuery,abonoQuery,trasplanteQuery,limpiezaQuery,podaQuery,multiplicacionQuery,floracionQuery,substratoQuery,trasplanteQuery,descansoQuery,info_adicionalQuery],
        function(transaction, result) {
            console.log('    Insertada');
            window.location.href = './misPlantas.html';
        }
    );
}

//Edicion de planta
function editPlanta(tx){
    console.log('      editPlanta, idMiPlanta=>'+idPlanta);
    var idIndiceQuery = (idIndice != undefined && idIndice.length>0)?idIndice:null;
    var ultimoRiegoQuery = (ultimoRiego != undefined && ultimoRiego!=null)?ultimoRiego:null;
    var frecuenciaQuery = (frecuencia != undefined && frecuencia>0)?frecuencia:0;
    var luzQuery = (luz != undefined && luz.length>0)?luz:null;

    var temperaturaQuery = (temperatura != undefined && temperatura.length>0)?temperatura:null;
    var humedadQuery = (humedad != undefined && humedad.length>0)?humedad:null;
    var riegoQuery = (riego != undefined && riego.length>0)?riego:null;
    var abonoQuery = (abono != undefined && abono.length>0)?abono:null;
    var trasplanteQuery = (trasplante != undefined && trasplante.length>0)?trasplante:null;
    var limpiezaQuery = (limpieza != undefined && limpieza.length>0)?limpieza:null;
    var podaQuery = (poda != undefined && poda.length>0)?poda:null;
    var multiplicacionQuery = (multiplicacion != undefined && multiplicacion.length>0)?multiplicacion:null;
    var floracionQuery = (floracion != undefined && floracion.length>0)?floracion:null;
    var substratoQuery = (substrato != undefined && substrato.length>0)?substrato:null;
    var trastornosQuery = (trastornos != undefined && trastornos.length>0)?trastornos:null;
    var descansoQuery = (descanso != undefined && descanso.length>0)?descanso:null;
    var info_adicionalQuery = (info_adicional != undefined && info_adicional.length>0)?info_adicional:null;

    var query = 'UPDATE MI_PLANTA SET NOMBRE=?, DESCRIPCION=?,ULTIMO_RIEGO=?,FRECUENCIA_RIEGO=?,LUZ=?, '
        +' TEMPERATURA=?,HUMEDAD=?,RIEGO=?,ABONO=?,TRASPLANTE=?,LIMPIEZA=?,PODA=?,MULTIPLICACION=?,FLORACION=?,SUBSTRATO=?,TRASTORNOS=?,DESCANSO=?,INFO_ADICIONAL=?'
        +' WHERE ID_MI_PLANTA='+idPlanta;
    tx.executeSql(query, [nombre, descripcion,ultimoRiego,parseInt(frecuenciaQuery),luzQuery,temperaturaQuery,humedadQuery,riegoQuery,abonoQuery,trasplanteQuery,limpiezaQuery,podaQuery,multiplicacionQuery,floracionQuery,substratoQuery,trastornosQuery,descansoQuery,info_adicionalQuery],
        function(transaction, result) {
            console.log('    Actualizada');
            window.location.href = './misPlantas.html';
        }
    );
}

//Eliminar planta
function deletePlanta(tx){
    console.log('      deletePlanta, idMiPlanta=>'+idPlanta);
    var query = 'DELETE FROM MI_PLANTA WHERE ID_MI_PLANTA='+idPlanta;
    tx.executeSql(query, [],
        function(transaction, result) {
            console.log('    Eliminada');
            window.location.href = './misPlantas.html';
        }
    );
}

//Funcion para parseo de fechas a la fech alocal
function toDateInputValue (local) {
    local.setMinutes(local.getMinutes() - local.getTimezoneOffset());
    return local.toJSON().slice(0,10);
}



/***********/
/* ERRORES */
/***********/

//Error en populate
function errorCB(err){
    console.log("    Error processing SQL: "+err.message);
}

//OK en populate
function successCB(){
    console.log('    oK');
}

//Error al procesar sql
function errorHandler(transaction, error) {
    console.log('    Error: ' + error.message + ' code: ' + error.code);
}