var datosPlagas=[];
var idCuidado;

var dataTablePlagas;

$(document).ready(function() {
    if ($('#tablaPlagas').length>0){
        cargarPlagas();
    }

    if ($('#detallePlaga').length>0){
        var search = $(location).attr('search')
        idCuidado = search.substring(search.indexOf('idCuidado')+10);
        detallesPlaga();
    }
} );

function cargarPlagas(){
    console.log('  CargarPlagas');
    document.addEventListener("deviceready", onDeviceReady, true);
}

function detallesPlaga(){
    console.log('  DetallePlaga=>'+idCuidado);
    document.addEventListener("deviceready", onDeviceReadyDetalle, true);
}

function onDeviceReady() {
    console.log('      DeviceReady');
    //var mydb = openDatabase('bdIplantaInterior.bd', '', 'BD Planta interior', 5000000);
    var mydb = openDatabase('iPlantaInterior', '1.0', 'iPlantaInterior DB', 10 * 1024);
    mydb.transaction(populateDB, errorCB, successCB);
}

function onDeviceReadyDetalle() {
    console.log('      DeviceReadyDetalle');
    //var mydb = openDatabase('bdIplantaInterior.bd', '', 'BD Planta interior', 5000000);
    var mydb = openDatabase('iPlantaInterior', '1.0', 'iPlantaInterior DB', 10 * 1024);
    mydb.transaction(populateDBDetalle, errorCB, successCB);
}

function populateDB(tx){
    console.log('      PopulateDB');
    tx.executeSql('select ID_CUIDADO, NOMBRE, IMAGEN from CUIDADO where ID_TIPO_CUIDADO=2 order by NOMBRE asc;', [],
        function(transaction, result) {
            if (result != null && result.rows != null) {
                for (var i = 0; i < result.rows.length; i++) {
                    var row = result.rows.item(i);
                    var fila = [''+row.ID_CUIDADO,(row.IMAGEN)?''+row.IMAGEN:'', ''+row.NOMBRE];
                    datosPlagas.push(fila);
                }
            }

            dataTablePlagas = $('#tablaPlagas').DataTable({
                "lengthChange": false,
                data: datosPlagas,
                "order": [[2, "asc"]],
                "columns": [
                    // Ordenacion y ancho de columnas
                    {},
                    { orderable: false, width: "20%"},
                    {},
                    { orderable: false, width: "10%"},
                ],
                "columnDefs": [
                    {
                        "targets": [0],
                        "visible": false,
                        "searchable": false
                    },
                    {
                        // Renderizacion de las celdas
                        "render": function ( data, type, row ) {
                            if (row[1]!=null && row[1].length>0){
                                return '<img src="' + row[1] + '" alt="Imagen '+row[2]+'"/>';
                            }
                            else{
                                return '';
                            }
                        },
                        "targets": [1]
                    },
                    {
                        // Renderizacion de las celdas
                        "render": function ( data, type, row ) {
                            return '<div class="iconDetalle" id="irDetallePlaga" ident="'+row[0]+'"><i class="fas fa-arrow-right" ></i></div>';
                        },
                        "targets": [3]
                    }
                ],
                // Traducciones de la tabla
                "language": {
                    "processing":     "Procesando...",
                    "lengthMenu":     "Mostrar _MENU_ registros",
                    "zeroRecords":    "No se encontraron resultados",
                    "emptyTable":     "Ningún dato disponible en esta tabla",
                    "info":           "Mostrando registros del _START_ al _END_ de un total de _TOTAL_ registros",
                    "infoEmpty":      "0 - 0 de 0",
                    "infoFiltered":   "(filtrado de un total de _MAX_ registros)",
                    "infoPostFix":    "",
                    "search":         "Buscar:   ",
                    "thousands":  ",",
                    "loadingRecords": "Cargando...",
                    "paginate": {
                        "first":    "<i class='glyphicon glyphicon-chevron-left'></i><i class='glyphicon glyphicon-chevron-left'></i>",
                        "last":     "<i class='glyphicon glyphicon-chevron-right'></i><i class='glyphicon glyphicon-chevron-right'></i>",
                        "next":     "<i class='glyphicon glyphicon-chevron-right'></i>",
                        "previous": "<i class='glyphicon glyphicon-chevron-left'></i>"
                    },
                    "aria": {
                        "sortAscending":  ": Activar para ordenar la columna de manera ascendente",
                        "sortDescending": ": Activar para ordenar la columna de manera descendente"
                    }
                },
                "initComplete" : function() {
                    var altura = parseInt($(window).height() - $('#migaPan').height() - $('#tablaPlagas_filter').height() - $('.menu').height());
                    var altoFila = 130;
                    if ( parseInt($(window).height())<= 750) {
                        altoFila = 60;
                    }
                    var filas = Math.trunc(altura/altoFila)-1;
                    $('#tablaPlagas').DataTable().page.len(filas).draw();
                },
                pageResize: true,
                paging: false,
                info: false
            });
            
        },
    errorHandler);

}

function populateDBDetalle(tx){
    console.log('      PopulateDBDetalle, idPlaga=>'+idCuidado);
    tx.executeSql('select ID_CUIDADO, NOMBRE, IMAGEN, RESUMEN, TEXTO from CUIDADO where ID_CUIDADO='+idCuidado+';', [],
        function(transaction, result) {
            if (result != null && result.rows != null) {
                for (var i = 0; i < result.rows.length; i++) {
                    var row = result.rows.item(i);
                    $('#nombreMigaPan').text(row.NOMBRE.toUpperCase());
                    $('#nombreCuidado').html(row.NOMBRE.toUpperCase());
                    if (row.IMAGEN!=null  && row.IMAGEN!='null' && row.IMAGEN.length>0){
                        $('#imagen1').attr('src',row.IMAGEN);
                    }
                    else{
                        $('#cardImagen').hide();
                        $("#cardImagen").css("display", "none");
                    }

                    if (row.RESUMEN!=null && row.RESUMEN.length>0){
                        $('#resumenCuidado').html(row.RESUMEN);
                    }
                    else{
                        $('#cardResumen').hide();
                        $("#cardResumen").css("display", "none");
                    }
                    if (row.TEXTO!=null && row.TEXTO.length>0){
                        $('#desCuidado').html(row.TEXTO);
                    }
                    else{
                        $('#cardDescripcion').hide();
                        $("#cardDescripcion").css("display", "none");
                    }
                }
            }
        },
    errorHandler);
}


//Detalle de la plaga
$(document).on("click",'#irDetallePlaga', function ()
{
    var id = $(this).attr("ident");
    window.location.href = './plaga.html?idCuidado='+id;
});

$(document).on("touchend",'#irDetallePlaga', function ()
{
    var id = $(this).attr("ident");
    window.location.href = './plaga.html?idCuidado='+id;
});

//Error en populate
function errorCB(err){
    console.log("    Error processing SQL: "+err.message);
}

//OK en populate
function successCB(){
    console.log('    oK');
}

//Error al procesar sql
function errorHandler(transaction, error) {
    console.log('    Error: ' + error.message + ' code: ' + error.code);
}